<?php

namespace app\models;

use explosivebit\arangodb\ActiveRecord;

abstract class Edge extends ActiveRecord
{
    public function attributes()
    {
        return ['_key', '_from', '_to', 'date', 'type', 'account'];
    }

    public function rules()
    {
        return [
            [
                ['_from', '_to', 'date', 'type', 'account'],
                'required',
                'message' => 'Заполните поле: {attribute}'
            ],
            [
                'date',
                'integer'
            ],
            [
                'type',
                'string'
            ],
            [
                'account',
                'string'
                // Надо добавить проверку существования аккаунта
            ]
        ];
    }

    public function attributeLabels()
    {
        return [
            'date' => 'Дата',
            'type' => 'Тип',
            'account' => 'Аккаунт'
        ];
    }

    public function beforeSave($data)
    {
        if (parent::beforeSave($data)) {
            if ($this->isNewRecord) {
                $this->date = time();
            }

            return true;
        }

        return false;
    }
}
