function identification() {
    $.ajax({
        url: '/identification',
        type: 'post',
        dataType: 'json',
        data: { '_csrf': yii.getCsrfToken() },
        success: function (data) {
            if (data.nav !== undefined) {
                // Обновление документа
                document.getElementsByTagName('nav')[0].innerHTML = data.nav;
            }
            if (data.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.redirect);
            }
            if (data._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data._csrf);
            }
        }
    });
}

function authentication(form) {
    if (form == undefined) {
        form = { '_csrf': yii.getCsrfToken() };
    } else {
        form = $(form).serialize();
    }

    $.ajax({
        url: '/authentication',
        type: 'post',
        dataType: 'json',
        data: form,
        success: function (data, status) {
            if (data.nav !== undefined) {
                // Обновление документа
                document.getElementsByTagName('nav')[0].innerHTML = data.nav;
            }
            if (data.main !== undefined && document.getElementById('page_index') === null) {
                // Обновление документа
                document.getElementsByTagName('main')[0].innerHTML = data.main;

                // Реинициализация
                reinitialization();
            }
            if (data.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.redirect);
            }
            if (data._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data._csrf);
            }
        },
        error: function (data, status) {
            if (data.responseJSON.main !== undefined) {
                // Обновление документа
                document.getElementsByTagName('main')[0].innerHTML = data.responseJSON.main;
            }
            if (data.responseJSON.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.responseJSON.redirect);
            }
            if (data.responseJSON._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data.responseJSON._csrf);
            }
        }
    });
}

function deauthentication() {
    $.ajax({
        url: '/deauthentication',
        type: 'post',
        dataType: 'json',
        data: { '_csrf': yii.getCsrfToken() },
        success: function (data) {
            if (data.nav !== undefined) {
                // Обновление документа
                document.getElementsByTagName('nav')[0].innerHTML = data.nav;
            }
            if (data.main !== undefined) {
                // Обновление документа
                document.getElementsByTagName('main')[0].innerHTML = data.main;

                // Реинициализация
                reinitialization();
            }
            if (data.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.redirect);
            }
            if (data._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data._csrf);
            }
        }
    });
}

function registration(form) {
    if (form == undefined) {
        form = { '_csrf': yii.getCsrfToken() };
    } else {
        form = $(form).serialize();
    }

    $.ajax({
        url: '/registration',
        type: 'post',
        dataType: 'json',
        data: form,
        success: function (data) {
            if (data.nav !== undefined) {
                // Обновление документа
                document.getElementsByTagName('nav')[0].innerHTML = data.nav;
            }
            // Разобраться нужна ли ещё првоерка на page_index, избавиться от неё
            if (data.main !== undefined && document.getElementById('page_index') === null) {
                // Обновление документа
                document.getElementsByTagName('main')[0].innerHTML = data.main;

                // Реинициализация
                reinitialization();
            }
            if (data.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.redirect);
            }
            if (data._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data._csrf);
            }
        },
        error: function (data) {
            if (data.responseJSON.main !== undefined) {
                // Обновление документа
                document.getElementsByTagName('main')[0].innerHTML = data.responseJSON.main;
            }
            if (data.responseJSON.redirect !== undefined) {
                // Перенаправление
                history.pushState({}, document.title, data.responseJSON.redirect);
            }
            if (data.responseJSON._csrf !== undefined) {
                // Обновление документа
                $('meta[name=csrf-token]').prop("content", data.responseJSON._csrf);
            }
        }
    });
}

document.addEventListener('DOMContentLoaded', identification(), true);